/// @file taxiMap.js
/// @author Mario Chirinos Colunga
/// @date 2016-04-15
/// 
Number.prototype.toRadians = function()
{
	return this * Math.PI / 180;
};
function distance(lng1,lat1,lng2,lat2)
{
	
	var R = 6371e3; // metres
	var f1 = lat1.toRadians();
	var f2 = lat2.toRadians();
	var df = (lat2-lat1).toRadians();
	var dl = (lng2-lng1).toRadians();

	var a = Math.sin(df/2) * Math.sin(df/2) +
		Math.cos(f1) * Math.cos(f2) *
		Math.sin(dl/2) * Math.sin(dl/2);
	var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));

	var d = R * c;
	return d;
};
//------------------------------------------------------------------------------
/**
 * Definitions for the languages.
 * @param  divID div name to insert the map
 * @param  lng Longitude
 * @param  lat Latitude
 * @param  z Zoom
 * @return OpenStreetMapsClass object
 */
function sidtMap(divID, lng, lat, z)
{
	OpenStreetMapsClass.call(this, divID, lng, lat, z);
	var self = this;
	this.areaPoints = [];


	var poly = new ol.geom.Polygon([]);

//	var poly = new ol.geom.Polygon([[ol.proj.transform([-18,-22], 'EPSG:4326', 'EPSG:3857'),
//	    ol.proj.transform([-44,-55], 'EPSG:4326', 'EPSG:3857'),
//	    ol.proj.transform([-88,75], 'EPSG:4326', 'EPSG:3857')]]);

	var style = new ol.style.Style({stroke: new ol.style.Stroke({color: 'rgba(0,0,100,0.8)', width: 2}),
					 fill: new ol.style.Fill({ color: 'rgba(0,100,200,0.5)'}) });
	this.polygon = new ol.Feature({geometry: poly, name: 'My Polygon'});
	this.polygon.setStyle(style);
	this.vectorLayer.getSource().addFeature(this.polygon);

	this.map.on("moveend",function(e){self.onMapMove(e)});
	this.map.on("pointerdrag",function(e){self.onDrag(e)});
	this.map.on("pointermove",function(e){self.onMousemove(e)});
 
};
sidtMap.prototype = Object.create( OpenStreetMapsClass.prototype );
//------------------------------------------------------------------------------
sidtMap.prototype.onMousemove = function(e)
{
	console.log("onMousemove");
	console.log("areaPoints");
	console.log(this.areaPoints);
	if(this.areaPoints.length ==  1)
	{
		console.log("draw");
		var coor = [];
		coor.push(this.areaPoints[0]);
		coor.push([this.areaPoints[0][0],e.coordinate[1]]);
		coor.push([e.coordinate[0], this.areaPoints[0][1]]);
		coor.push(e.coordinate);
		console.log(coor);
		this.polygon.getGeometry().setCoordinates(coor);
//		this.polygon.setGeometry(geom);
//		this.polygon.getGeometry().setCoordinates(
//		[[ol.proj.transform([-18,-22], 'EPSG:4326', 'EPSG:3857'),
//	    ol.proj.transform([-44,-55], 'EPSG:4326', 'EPSG:3857'),
//	    ol.proj.transform([-88,75], 'EPSG:4326', 'EPSG:3857')]]);
	}
	console.log(this.polygon.getGeometry().getCoordinates());
}
//------------------------------------------------------------------------------
sidtMap.prototype.onMapMove = function(e)
{
	var lnglat = ol.proj.transform(this.map.getView().getCenter(), 'EPSG:3857', 'EPSG:4326');
	console.log("onMapMove");

	

};
//------------------------------------------------------------------------------
sidtMap.prototype.onDrag = function(e)
{
	console.log("onDrag");
};
//------------------------------------------------------------------------------
sidtMap.prototype.onMapClick = function(e)
{
	console.log("onMapClick");
	var lnglat = ol.proj.transform(e.coordinate, 'EPSG:3857', 'EPSG:4326');	
//	console.log(lnglat);

	if(this.areaPoints.length >=2 )
	{
		this.areaPoints = [];
		this.polygon.getGeometry().setCoordinates([])
	}
	var coor = this.polygon.getGeometry().getCoordinates();
	coor.push(e.coordinate);
	this.polygon.getGeometry().setCoordinates(coor);
	this.areaPoints.push(e.coordinate);


//	console.log(ol.proj.transform([-18,-22], 'EPSG:4326', 'EPSG:3857'));
};

//------------------------------------------------------------------------------



